function MakeVariablePath(v)
{
  path = [];
  return BuildVariablePath(path, v);
}

function BuildVariablePath(path, v)
{
  path.unshift(v.name);
  path.unshift("find_variable");
  var c = v.parentElement.QueryInterface(Components.interfaces.cellml_apiICellMLComponent);
  return BuildComponentPath(path, c)
}

function BuildComponentPath(path, c)
{
  path.unshift(c.name);
  path.unshift("find_component");
  return BuildModelPath(path, c.modelElement);
}

function BuildModelPath(path, m)
{
  var pe = m.parentElement;
  if (pe == null)
    return path;

  var imp = pe.QueryInterface(Components.interfaces.cellml_apiICellMLImport);
  // This assumes at least one import component (good assumption for
  // variable paths, but not always for unit only imports)...
  var iceg = imp.components.iterateImportComponents().nextImportComponent();
  path.unshift(iceg.name);
  path.unshift("find_import_by_component");
  return BuildModelPath(imp.modelElement);
}

function FindElementByPath(path, m)
{
  var operators =
  {
    find_component: function (name, model)
    {
      return model.localComponents.getComponent(name);
    },

    find_variable: function (name, component)
    {
      return component.variables.getVariable(name);
    },

    find_import_by_component: function (name, model)
    {
      return model.modelComponents.getComponent(name).parentElement.
        QueryInterface(Components.interfaces.cellml_apiICellMLImport).
        importedModel;
    }
  };

  var operand2 = m;
  while (path.length > 1)
  {
    var operator = path.shift();
    var operand1 = path.shift();
    operand2 = operators[operator](operand1, operand2);
  }
  if (path.length != 0)
    alert("Warning: junk at end of an element path.");

  return operand2;
}
